Disabled Modules Can't Be Upgraded or Enabled

I’m a bit stumped on this. I logged into a FreePBX server and noticed that 6 modules were disabled. I went to look at the Module Admin page and was met with an error.

Exception (404)

Unable to locate the FreePBX BMO Class 'Cdr'A required module might be disabled or uninstalled. Recommended steps (run from the CLI): 1) fwconsole ma install cdr 2) fwconsole ma enable cdr

I logged into the ssh console and first ran “fwconsle chown”. I recieved the error:

[[email protected] ~]# fwconsole chown
Taking too long? Customize the chown command, See http://wiki.freepbx.org/displa                                                                 y/FOP/FreePBX+Chown+Conf
Setting Permissions...

In Self_Helper.class.php line 212:

  Unable to locate the FreePBX BMO Class 'Cdr'A required module might be disa
  bled or uninstalled. Recommended steps (run from the CLI): 1) fwconsole ma
  install cdr 2) fwconsole ma enable cdr

Then ran “fwconsole ma list”. Here is the output:

[[email protected] ~]# fwconsole ma list
No repos specified, using: [standard] from last GUI settings

+----------------------+------------+-----------------------------------------+-------------+
| Module               | Version    | Status                                  | License     |
+----------------------+------------+-----------------------------------------+-------------+
| accountcodepreserve  | 13.0.2.2   | Enabled                                 | GPLv2       |
| amd                  | 15.0.3     | Enabled                                 | GPLv3+      |
| announcement         | 15.0.3.13  | Enabled                                 | GPLv3+      |
| api                  | 15.0.3.22  | Enabled                                 | AGPLv3+     |
| areminder            | 15.0.14.26 | Enabled                                 | Commercial  |
| arimanager           | 15.0.3.13  | Enabled                                 | GPLv3+      |
| asterisk-cli         | 14.0.4     | Enabled                                 | GPLv3+      |
| asteriskinfo         | 15.0.14    | Enabled                                 | GPLv3+      |
| backup               | 15.0.10.68 | Enabled                                 | GPLv3+      |
| blacklist            | 15.0.2.17  | Enabled                                 | GPLv3+      |
| broadcast            | 15.0.14    | Enabled                                 | Commercial  |
| builtin              |            | Enabled                                 |             |
| bulkhandler          | 15.0.3     | Enabled                                 | GPLv3+      |
| calendar             | 15.0.4.21  | Enabled                                 | GPLv3+      |
| callaccounting       | 15.0.24    | Enabled                                 | Commercial+ |
| callback             | 15.0.12    | Enabled                                 | GPLv3+      |
| callerid             | 15.0.16    | Enabled                                 | Commercial  |
| callforward          | 15.0.16    | Enabled                                 | AGPLv3+     |
| calllimit            | 15.0.5.6   | Enabled                                 | Commercial  |
| callrecording        | 15.0.7.22  | Enabled                                 | AGPLv3+     |
| callwaiting          | 15.0.4.6   | Enabled                                 | GPLv3+      |
| campon               | 13.0.4.1   | Enabled                                 | GPLv3+      |
| cdr                  | 15.0.17.13 | Disabled; Pending upgrade to 15.0.17.15 | GPLv3+      |
| cel                  | 15.0.15.15 | Enabled                                 | GPLv3+      |
| certman              | 15.0.48    | Enabled                                 | AGPLv3+     |
| cidlookup            | 15.0.20    | Enabled                                 | GPLv3+      |
| conferences          | 15.0.7.11  | Enabled                                 | GPLv3+      |
| conferencespro       | 15.0.3.18  | Enabled                                 | Commercial  |
| configedit           | 13.0.7.3   | Enabled                                 | AGPLv3+     |
| contactmanager       | 15.0.8.48  | Enabled                                 | GPLv3+      |
| core                 | 15.0.12.98 | Enabled                                 | GPLv3+      |
| cos                  | 15.0.14    | Enabled                                 | Commercial  |
| customappsreg        | 15.0.14    | Enabled                                 | GPLv3+      |
| cxpanel              | 15.0.4     | Enabled                                 | GPLv3       |
| dahdiconfig          | 15.0.5.8   | Enabled                                 | GPLv3+      |
| dashboard            | 15.0.12    | Enabled                                 | AGPLv3+     |
| daynight             | 15.0.12    | Enabled                                 | GPLv3+      |
| dictate              | 15.0.7     | Enabled                                 | GPLv3+      |
| digium_phones        | 15.0.10    | Enabled                                 | GPLv2       |
| digiumaddoninstaller | 13.0.1.2   | Enabled                                 | GPLv2       |
| directory            | 15.0.18    | Enabled                                 | GPLv3+      |
| disa                 | 15.0.4.9   | Enabled                                 | AGPLv3+     |
| donotdisturb         | 15.0.10    | Enabled                                 | GPLv3+      |
| dundicheck           | 2.11.0.3   | Enabled                                 | GPLv3+      |
| endpoint             | 15.0.41.41 | Disabled; Pending upgrade to 15.0.41.47 | Commercial  |
| extensionroutes      | 15.0.8     | Enabled                                 | Commercial  |
| extensionsettings    | 13.0.4     | Enabled                                 | GPLv3+      |
| fax                  | 15.0.22    | Enabled                                 | GPLv3+      |
| faxpro               | 15.0.8.15  | Enabled                                 | Commercial  |
| featurecodeadmin     | 13.0.6.11  | Enabled                                 | GPLv3+      |
| filestore            | 15.0.3.27  | Enabled                                 | AGPLv3      |
| findmefollow         | 15.0.31    | Enabled                                 | GPLv3+      |
| firewall             | 15.0.27    | Enabled                                 | AGPLv3+     |
| framework            | 15.0.17.64 | Disabled; Pending upgrade to 15.0.17.67 | GPLv2+      |
| freepbx_ha           |            | Not Installed (Locally available)       | Commercial  |
| fw_langpacks         | 14.0.1     | Enabled                                 | GPLv3+      |
| hotelwakeup          | 15.0.5.5   | Enabled                                 | GPLv2       |
| iaxsettings          | 15.0.8     | Enabled                                 | AGPLv3      |
| infoservices         | 15.0.3     | Enabled                                 | GPLv2+      |
| irc                  | 13.0.1     | Enabled                                 | GPLv3+      |
| ivr                  | 15.0.29    | Enabled                                 | GPLv3+      |
| languages            | 15.0.12    | Enabled                                 | GPLv3+      |
| logfiles             | 15.0.15    | Enabled                                 | GPLv3+      |
| manager              | 15.0.15    | Enabled                                 | GPLv2+      |
| miscapps             | 15.0.10    | Enabled                                 | GPLv3+      |
| miscdests            | 15.0.2.12  | Enabled                                 | GPLv3+      |
| missedcall           | 13.0.3     | Enabled                                 | Commercial  |
| music                | 15.0.22    | Enabled                                 | GPLv3+      |
| outroutemsg          | 15.0.9     | Enabled                                 | GPLv3+      |
| paging               | 15.0.4.32  | Enabled                                 | GPLv3+      |
| pagingpro            | 15.0.1.22  | Enabled                                 | Commercial  |
| parking              | 15.0.15.4  | Enabled                                 | GPLv3+      |
| parkpro              | 15.0.13    | Enabled                                 | Commercial  |
| pbdirectory          | 2.11.0.6   | Enabled                                 | GPLv3+      |
| phonebook            | 15.0.12    | Enabled                                 | GPLv3+      |
| phpinfo              | 13.0.2     | Enabled                                 | GPLv2+      |
| pinsets              | 15.0.1.15  | Enabled                                 | GPLv3+      |
| pinsetspro           | 15.0.4     | Enabled                                 | Commercial  |
| pm2                  | 15.0.7     | Enabled                                 | AGPLv3+     |
| pms                  | 15.0.2.55  | Disabled; Pending upgrade to 15.0.2.57  | Commercial  |
| presencestate        | 15.0.11    | Enabled                                 | GPLv3+      |
| printextensions      | 13.0.3.4   | Enabled                                 | GPLv3+      |
| queuemetrics         | 2.11.0.3   | Enabled                                 | GPLv3+      |
| queueprio            | 15.0.10    | Enabled                                 | GPLv3+      |
| queues               | 15.0.33    | Enabled                                 | GPLv2+      |
| queuestats           | 15.0.3.34  | Enabled                                 | Commercial  |
| qxact_reports        | 15.0.3.34  | Enabled                                 | Commercial  |
| recording_report     | 15.0.4.40  | Enabled                                 | Commercial  |
| recordings           | 15.0.3.15  | Disabled; Pending upgrade to 15.0.3.16  | GPLv3+      |
| restapi              | 13.0.21.2  | Enabled                                 | AGPLv3      |
| restapps             | 15.0.20    | Enabled                                 | Commercial  |
| ringgroups           | 15.0.11.15 | Enabled                                 | GPLv3+      |
| sangomacrm           | 15.0.23.6  | Enabled                                 | Commercial  |
| setcid               | 15.0.9     | Enabled                                 | GPLv3+      |
| sipsettings          | 15.0.6.39  | Enabled                                 | AGPLv3+     |
| sipstation           | 15.0.5.25  | Disabled; Pending upgrade to 15.0.5.26  | Commercial  |
| sms                  | 15.0.24    | Enabled                                 | Commercial  |
| soundlang            | 15.0.5.10  | Enabled                                 | GPLv3+      |
| speeddial            | 2.11.0.4   | Enabled                                 | GPLv3+      |
| superfecta           | 15.0.2.35  | Enabled                                 | GPLv2+      |
| sysadmin             | 15.0.21.99 | Enabled                                 | Commercial  |
| timeconditions       | 15.0.15.11 | Enabled                                 | GPLv3+      |
| tts                  | 15.0.12    | Enabled                                 | GPLv3+      |
| ttsengines           | 15.0.4.7   | Enabled                                 | AGPLv3      |
| ucp                  | 15.0.12    | Enabled                                 | AGPLv3+     |
| userman              | 15.0.67    | Enabled                                 | AGPLv3+     |
| vega                 | 15.0.12    | Enabled                                 | Commercial+ |
| versionupgrade       | 15.0.25    | Enabled                                 | Commercial  |
| vmblast              | 15.0.11.8  | Enabled                                 | GPLv3+      |
| vmnotify             | 15.0.13    | Enabled                                 | Commercial  |
| voicemail            | 15.0.18.47 | Enabled                                 | GPLv3+      |
| voicemail_report     | 15.0.6     | Enabled                                 | Commercial  |
| vqplus               | 15.0.7.22  | Enabled                                 | Commercial  |
| weakpasswords        | 13.0.2     | Enabled                                 | GPLv3+      |
| webcallback          | 15.0.6.3   | Enabled                                 | Commercial  |
| webrtc               | 15.0.10.7  | Enabled                                 | GPLv3+      |
| xmpp                 | 15.0.6.9   | Enabled                                 | AGPLv3      |
| zulu                 | 15.0.58.12 | Enabled                                 | Commercial  |
+----------------------+------------+-----------------------------------------+-------------+

I tried to run “fwconsole ma upgradeall” and received errors on all the modules that were attempted:

[[email protected] ~]# fwconsole ma upgradeall
No repos specified, using: [standard] from last GUI settings

Module(s) requiring upgrades: cdr, endpoint, framework, pms, recordings, sipstation
Upgrading module 'framework' from 15.0.17.67 to 15.0.17.67
Downloading module 'framework'
Processing framework
Verifying local module download...Verified
Extracting...Done
Download completed in 2 seconds
Updating tables admin, ampusers, cronmanager, featurecodes, freepbx_log, freepbx_settings, globals, module_xml, modules, notifications, cron_jobs...Done
Determined Asterisk version to be: 16.20.0

In install.php line 130:

  unlink(/var/www/html/admin/assets/config.php): Operation not permitted


moduleadmin [-f|--force] [-d|--debug] [--edge] [--ignorecache] [--stable] [--color] [--skipchown] [-e|--autoenable] [--skipdisabled] [--snapshot SNAPSHOT] [--format FORMAT] [-R|--repo REPO] [-t|--tag TAG] [--skipbreakingcheck] [--sendemail] [--onlystdout] [--] [<args>]...

Upgrading module 'cdr' from 15.0.17.15 to 15.0.17.15
Downloading module 'cdr'
Processing cdr
Verifying local module download...Verified
Extracting...Done
Download completed in 1 seconds
Detected Missing Dependency of: framework 13.0.1beta3.56
Found local Dependency of: framework 15.0.17.67
Installing Missing Dependency of: framework 13.0.1beta3.56
Updating tables admin, ampusers, cronmanager, featurecodes, freepbx_log, freepbx_settings, globals, module_xml, modules, notifications, cron_jobs...Done
Determined Asterisk version to be: 16.20.0

In install.php line 130:

  unlink(/var/www/html/admin/assets/config.php): Operation not permitted


moduleadmin [-f|--force] [-d|--debug] [--edge] [--ignorecache] [--stable] [--color] [--skipchown] [-e|--autoenable] [--skipdisabled] [--snapshot SNAPSHOT] [--format FORMAT] [-R|--repo REPO] [-t|--tag TAG] [--skipbreakingcheck] [--sendemail] [--onlystdout] [--] [<args>]...

Upgrading module 'endpoint' from 15.0.41.47 to 15.0.41.47
Downloading module 'endpoint'
Processing endpoint
Verifying local module download...Verified
Extracting...Done
Download completed in 4 seconds
Detected Missing Dependency of: cdr 15.0.17.13
Found local Dependency of: cdr 15.0.17.15
Detected Missing Dependency of: framework 13.0.1beta3.56
Found local Dependency of: framework 15.0.17.67
Installing Missing Dependency of: framework 13.0.1beta3.56
Updating tables admin, ampusers, cronmanager, featurecodes, freepbx_log, freepbx_settings, globals, module_xml, modules, notifications, cron_jobs...Done
Determined Asterisk version to be: 16.20.0

In install.php line 130:

  unlink(/var/www/html/admin/assets/config.php): Operation not permitted


moduleadmin [-f|--force] [-d|--debug] [--edge] [--ignorecache] [--stable] [--color] [--skipchown] [-e|--autoenable] [--skipdisabled] [--snapshot SNAPSHOT] [--format FORMAT] [-R|--repo REPO] [-t|--tag TAG] [--skipbreakingcheck] [--sendemail] [--onlystdout] [--] [<args>]...

Upgrading module 'pms' from 15.0.2.57 to 15.0.2.57
Downloading module 'pms'
Processing pms
Verifying local module download...Verified
Extracting...Done
Download completed in 1 seconds
Detected Missing Dependency of: framework 14.0.1.23
Found local Dependency of: framework 15.0.17.67
Installing Missing Dependency of: framework 14.0.1.23
Updating tables admin, ampusers, cronmanager, featurecodes, freepbx_log, freepbx_settings, globals, module_xml, modules, notifications, cron_jobs...Done
Determined Asterisk version to be: 16.20.0

In install.php line 130:

  unlink(/var/www/html/admin/assets/config.php): Operation not permitted


moduleadmin [-f|--force] [-d|--debug] [--edge] [--ignorecache] [--stable] [--color] [--skipchown] [-e|--autoenable] [--skipdisabled] [--snapshot SNAPSHOT] [--format FORMAT] [-R|--repo REPO] [-t|--tag TAG] [--skipbreakingcheck] [--sendemail] [--onlystdout] [--] [<args>]...

Upgrading module 'recordings' from 15.0.3.16 to 15.0.3.16
Downloading module 'recordings'
Processing recordings
Verifying local module download...Verified
Extracting...Done
Download completed in 0 seconds
Detected Missing Dependency of: framework 13.0.72
Found local Dependency of: framework 15.0.17.67
Installing Missing Dependency of: framework 13.0.72
Updating tables admin, ampusers, cronmanager, featurecodes, freepbx_log, freepbx_settings, globals, module_xml, modules, notifications, cron_jobs...Done
Determined Asterisk version to be: 16.20.0

In install.php line 130:

  unlink(/var/www/html/admin/assets/config.php): Operation not permitted


moduleadmin [-f|--force] [-d|--debug] [--edge] [--ignorecache] [--stable] [--color] [--skipchown] [-e|--autoenable] [--skipdisabled] [--snapshot SNAPSHOT] [--format FORMAT] [-R|--repo REPO] [-t|--tag TAG] [--skipbreakingcheck] [--sendemail] [--onlystdout] [--] [<args>]...

Upgrading module 'sipstation' from 15.0.5.26 to 15.0.5.26
Downloading module 'sipstation'
Processing sipstation
Verifying local module download...Verified
Extracting...Done
Download completed in 0 seconds
Detected Missing Dependency of: framework 15.0.6.18
Found local Dependency of: framework 15.0.17.67
Installing Missing Dependency of: framework 15.0.6.18
Updating tables admin, ampusers, cronmanager, featurecodes, freepbx_log, freepbx_settings, globals, module_xml, modules, notifications, cron_jobs...Done
Determined Asterisk version to be: 16.20.0

In install.php line 130:

  unlink(/var/www/html/admin/assets/config.php): Operation not permitted


moduleadmin [-f|--force] [-d|--debug] [--edge] [--ignorecache] [--stable] [--color] [--skipchown] [-e|--autoenable] [--skipdisabled] [--snapshot SNAPSHOT] [--format FORMAT] [-R|--repo REPO] [-t|--tag TAG] [--skipbreakingcheck] [--sendemail] [--onlystdout] [--] [<args>]...

All upgrades completed successfully!
Updating Hooks...Done
Chowning directories...
In Self_Helper.class.php line 212:

  Unable to locate the FreePBX BMO Class 'Cdr'A required module might be disabled or uninstalled. Recommended steps (run from the CLI): 1) fwc
  onsole ma install cdr 2) fwconsole ma enable cdr


moduleadmin [-f|--force] [-d|--debug] [--edge] [--ignorecache] [--stable] [--color] [--skipchown] [-e|--autoenable] [--skipdisabled] [--snapshot SNAPSHOT] [--format FORMAT] [-R|--repo REPO] [-t|--tag TAG] [--skipbreakingcheck] [--sendemail] [--onlystdout] [--] [<args>]...


[[email protected] ~]# sudo fwconsole chown
Taking too long? Customize the chown command, See http://wiki.freepbx.org/display/FOP/FreePBX+Chown+Conf
Setting Permissions...

In Self_Helper.class.php line 212:

  Unable to locate the FreePBX BMO Class 'Cdr'A required module might be disabled or uninstalled. Recommended steps (run from the CLI): 1) fwc
  onsole ma install cdr 2) fwconsole ma enable cdr


chown [-f|--file FILE] [-m|--module MODULE]

[[email protected] ~]# fwconsole ma install cdr
Detected Missing Dependency of: framework 13.0.1beta3.56
Found local Dependency of: framework 15.0.17.67
Installing Missing Dependency of: framework 13.0.1beta3.56
Updating tables admin, ampusers, cronmanager, featurecodes, freepbx_log, freepbx_settings, globals, module_xml, modules, notifications, cron_jobs...Done
Determined Asterisk version to be: 16.20.0

In install.php line 130:

  unlink(/var/www/html/admin/assets/config.php): Operation not permitted


moduleadmin [-f|--force] [-d|--debug] [--edge] [--ignorecache] [--stable] [--color] [--skipchown] [-e|--autoenable] [--skipdisabled] [--snapshot SNAPSHOT] [--format FORMAT] [-R|--repo REPO] [-t|--tag TAG] [--skipbreakingcheck] [--sendemail] [--onlystdout] [--] [<args>]...

I then tried to run “yum update” which only revealed one update: fail2ban-fpbx. I installed that, then tried the above again with no change in results.

I tried to enable the CDR module explicitly with “fwconsole ma enable cdr” and “fwconsole ma -f enable cdr”.

I tried to explicitly upgrade the CDR module with “fwconsole ma upgrade cdr”. Here is the result.

[[email protected] ~]# fwconsole ma -f enable cdr
The following error(s) occured:
 - Module cdr cannot be enabled
[[email protected] ~]# fwconsole ma -f upgrade cdr
No repos specified, using: [standard] from last GUI settings

cdr is the same as the online version, unable to upgrade
Updating Hooks...Done
Chowning directories...
In Self_Helper.class.php line 212:

  Unable to locate the FreePBX BMO Class 'Cdr'A required module might be disabled or uninstalled. Recommended steps (run from the CLI): 1) fwc
  onsole ma install cdr 2) fwconsole ma enable cdr

I tried reloading freepbx and received the same error about the CDR module.

[[email protected] ~]#  fwconsole reload
Reload Started

In Self_Helper.class.php line 212:

  Unable to locate the FreePBX BMO Class 'Cdr'A required module might be disabled or uninstalled. Recommended steps (run from the CLI): 1) fwc
  onsole ma install cdr 2) fwconsole ma enable cdr


reload [--json] [--dry-run] [--skip-registry-checks] [--dont-reload-asterisk]

I am not sure where to go from here. I don’t have access to the GUI Module Admin page. I don’t seem to have ability to manipulate the modules with cli using fwconsole ma. Thanks for any help!

Sorry to say, it looks like your system was compromised with malware. See K.php - a RestApps malicious script for some info. You can try to do some clean-up based on the notes in that thread.

This topic was automatically closed 30 days after the last reply. New replies are no longer allowed.